#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

void print(int x, int k) {
	//eprintf("print %d %d\n", x, k);
	for (int i = 0; i < k; i++)
		printf("%d", (x >> i) & 1);
}

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	int n;
	scanf("%d", &n);
	if (n == 1) {
		printf("01\n");
		return 0;
	}
	int k = 0;
	while((1LL << (1 << k)) < (1LL << (n - k))) k++;
	//eprintf("k = %d\n", k);
	for (int i = 0; i < (1 << (n - k)); i++) {
		int x = i / (1 << (1 << (k - 1)));
		int y = i % (1 << (1 << (k - 1)));
		int p = (1 << (1 << (k - 1))) - 1 + x - y;
		p &= (1 << (1 << (k - 1))) - 1;
		print(p, 1 << (k - 1));
		print(y, 1 << (k - 1));
	}
	printf("\n");

	return 0;
}
