// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = opt<int>(1);
	int m = opt<int>(2);
	int k = opt<int>(3);

	vector<vector<int>> field(n, vector<int>(m, -1));

	for (int i = 0; i < k; ++i) {
		while (true) {
			int x = rnd.next(0, n / 2 - 1) * 2;
			int y = rnd.next(0, m - 2);
			if (field[x][y] == -1 && field[x][y + 1] == -1) {
				int d;
				if (rnd.next(0, 1)) {
					d = 1;
				} else {
					d = 3;
				}
				field[x][y] = field[x][y + 1] = d;
				break;
			}
		}
	}

	cout << n << " " << n << "\n";
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (field[i][j] == -1) {
				cout << '.';
			} else {
				cout << field[i][j];
			}
		}
		cout << "\n";
	}

	return 0;
}