#include <bits/stdc++.h>
using namespace std;

const int INF = 1e9 + 10;
map<vector<int>, int> calc;

int solve(vector<int> &a, vector<vector<int>> &cost) {
  if (calc.count(a)) {
    return calc[a];
  }
  size_t firstNotZero = 0;
  while (firstNotZero < a.size() && a[firstNotZero] == 0) {
    firstNotZero++;
  }
  if (firstNotZero == a.size()) {
    return calc[a] = 0;
  }
  int &result = calc[a];
  result = INF;
  a[firstNotZero]--;
  for (size_t id = firstNotZero; id < a.size(); id++) {
    if (clock() * 1.0 / CLOCKS_PER_SEC > 0.9) {
      return result;
    }
    if (a[id] > 0) {
      a[id]--;
      result = min(result, cost[firstNotZero][id] + solve(a, cost));
      a[id]++;
    }
  }
  a[firstNotZero]++;
  return result;
}
 
int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0); 
  int n;
  cin >> n;
  vector<int> a(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
  }
  vector<vector<int>> cost(n, vector<int>(n));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      cin >> cost[i][j];
    }
  }
  int answer = solve(a, cost);
  if (answer == INF) {
    cout << -1 << '\n';
  }
  else {
    cout << answer << '\n';
  }
  if (answer == INF) {
    cerr << -1 << '\n';
  }
  else {
    cerr << answer << '\n';
  }
}     