#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <map>
#include <set>
#include <complex>
#include <string>
#include <unordered_map>
#include <unordered_set>
#include <random>

#define ft first
#define sc second
#define pb push_back
#define len(v) (int)v.size()
// #define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

int N = 19;
ll dp[21][11][21][2];// pos, dig, len, less 0
ll maxx = 1e18;

ll toll(string& s) {
	ll ans = 0;
	for (int i = 0; i < N; i++) {
		ans = ans * 10 + (s[i] - '0');
	}
	return ans;
}

ll calc(int x, string& s) {
	for (int i = 0; i <= N; i++) {
		for (int j = 0; j <= 10; j++) {
			for (int z = 0; z < x; z++) {
				for (int st = 0; st < 2; st++) {
					dp[i][j][z][st] = 0;
				}
			}
		}
	}
	dp[0][10][0][0] = 1;
	vector<vector<ll>> pref(11, vector<ll> (2, 0));
	vector<ll> sum(2, 0);
	for (int i = 0; i <= 10; i++) {
		for (int j = 0; j < x; j++) {
			for (int st = 0; st < 2; st++) {
				sum[st] += dp[0][i][j][st];
				pref[i][st] += dp[0][i][j][st];
			}
		}
	}
	for (int i = 0; i < N; i++) {
		if (s[i] == '0') {
			dp[i + 1][10][0][0] = dp[i][10][0][0];
			dp[i + 1][10][0][1] = dp[i][10][0][1];
		}
		else {
			dp[i + 1][10][0][1] = dp[i][10][0][0] + dp[i][10][0][1];
		}
		for (int dig = 0; dig < 10; dig++) {
			for (int cur = 2; cur < x; cur++) {
				dp[i + 1][dig][cur][1] += dp[i][dig][cur - 1][1];
				if (dig < s[i] - '0') {
					dp[i + 1][dig][cur][1] += dp[i][dig][cur - 1][0];
				}
				if (dig == s[i] - '0') {
					dp[i + 1][dig][cur][0] += dp[i][dig][cur - 1][0];
				}
			}
		}
		for (int dig = 0; dig < 10; dig++) {
			if (dig == 0) {
				dp[i + 1][dig][1][1] += sum[1] - pref[0][1] - pref[10][1];
				if (s[i] != '0') {
					dp[i + 1][dig][1][1] += sum[0] - pref[0][0] - pref[10][0];
				}
				if (s[i] == '0') {
					dp[i + 1][dig][1][0] += sum[0] - pref[0][0] - pref[10][0];
				}
				continue;
			}
			else {
				dp[i + 1][dig][1][1] += sum[1] - pref[dig][1];
				if (dig < s[i] - '0') {
					dp[i + 1][dig][1][1] += sum[0] - pref[dig][0];
				}
				if (dig == s[i] - '0') {
					dp[i + 1][dig][1][0] += sum[0] - pref[dig][0];
				}
			}
		}
		sum = vector<ll> (2, 0);
		pref = vector<vector<ll>> (11, vector<ll> (2, 0));
		for (int dig = 0; dig < 11; dig++) {
			for (int cur = 0; cur < x; cur++) {
				for (int st = 0; st < 2; st++) {
					sum[st] += dp[i + 1][dig][cur][st];
					pref[dig][st] += dp[i + 1][dig][cur][st];
				}
			}
		}
	}
	return toll(s) - sum[0] - sum[1] + 1;
}

signed main() {
	#ifdef PC
		freopen("in.txt", "r", stdin);
		freopen("out.txt", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		ll l, r;
		cin >> l >> r;
		l--;
		string ls = to_string(l), rs = to_string(r);
		if (r == maxx) {
			cout << 18 << " " << 1 << '\n';
			continue;
		}
		N = max(len(ls), len(rs)) + 1;
		while(len(ls) < N) 
			ls = "0" + ls;
		while(len(rs) < N) 
			rs = "0" + rs;

		ll ansl = 1, anss = r - l;
		if (N - 1 > 1) {
			ll a = calc(N - 1, ls), b = calc(N - 1, rs);
			if (b - a != 0) {
				cout <<  N - 1 << " " << b - a << '\n';
				continue;
			}
		}

		int lb = 1, rb = N;
		while (rb - lb > 1) {
			int mid = (lb + 2 * rb) / 3;
			ll a = calc(mid, ls), b = calc(mid, rs);
			if (b - a == 0) 
				rb = mid;
			else {
				ansl = mid, anss = b - a;
				lb = mid;
			}
		}
		cout << ansl << " " << anss << '\n';
	}
}