#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <ctime>
#include <cassert>
#include <complex>
#include <string>
#include <cstring>
#include <chrono>
#include <random>
#include <bitset>
using namespace std;

#ifdef LOCAL
	#define eprintf(...) fprintf(stderr, __VA_ARGS__);fflush(stderr);
#else
	#define eprintf(...) 42
#endif

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
template<typename T>
using pair2 = pair<T, T>;
using pii = pair<int, int>;
using pli = pair<ll, int>;
using pll = pair<ll, ll>;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll myRand(ll B) {
	return (ull)rng() % B;
}

#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define fi first
#define se second

clock_t startTime;
double getCurrentTime() {
	return (double)(clock() - startTime) / CLOCKS_PER_SEC;
}

pll solve(ll x, int k, ll p) {
	int mx = 1;
	int fst = x % 10;
	int prev = x % 10;
	x /= 10;
	int len = 1;
	k++;
	while(x > 0) {
		int c = x % 10;
		x /= 10;
		if (c == fst) {
			k++;
		} else fst = -2;
		if (c == prev) {
			len++;
		} else {
			mx = max(mx, len);
			prev = c;
			len = 1;
		}
	}
	mx = max(mx, len);
	if (mx >= k) {
		return mp((ll)mx, p);
	} else {
		return mp((ll)k, 1LL);
	}
}

void solve() {
	ll L, R;
	scanf("%lld%lld", &L, &R);
	R++;
	ll ans1 = 0, ans2 = 0;
	while(L < R) {
		ll p = 1;
		int k = 0;
		while(L + p <= R && L % p == 0) {
			p *= 10;
			k++;
		}
		p /= 10;
		k--;
		pll t = solve(L / p, k, p);
		if (t.first > ans1) {
			ans1 = t.first;
			ans2 = 0;
		}
		if (t.first == ans1) ans2 += t.second;
		L += p;
	}
	printf("%lld %lld\n", ans1, ans2);
}

int main()
{
	startTime = clock();
//	freopen("input.txt", "r", stdin);
//	freopen("output.txt", "w", stdout);

	int t;
	scanf("%d", &t);
	while(t--) solve();

	return 0;
}
