#include "testlib.h"
#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second

int n;
vector<pair<int, int>> p;

long long vp(long long x1, long long y1, long long x2, long long y2) {
    return x1 * y2 - x2 * y1;
}

bool lastOk(int last) {
    for (int i = 0; i < last - 1; i++) {
        if (p[i] == p[last]) {
            return false;
        }

        for (int j = i + 1; j < last; j++) {
            if (vp(p[j].x - p[i].x, p[j].y - p[i].y, p[last].x - p[i].x, p[last].y - p[i].y) == 0) {
                return false;
            }
        }
    }
    return true;
}

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);

    int n = atoi(argv[1]);
    int MAX = atoi(argv[2]);
    int s = atoi(argv[3]);

    p.resize(n);

    p[0].x = -MAX;
    p[0].y = -MAX;
    p[1].x = +MAX;
    p[1].y = -MAX;
    p[2].x = 0;
    p[2].y = MAX;

    for (int i = 3; i < n; i++) {
        do {
            p[i].x = rnd.next(-MAX/3, MAX/3);
            p[i].y = rnd.next(-MAX, 0);
        } while (!lastOk(i));
    }

    cout << n << endl;
    for (int i = 0; i < n; i++) {
        cout << p[i].x << " " << p[i].y << endl;
    }
    cout << s << endl;
}
