#include "testlib.h"
#include <bits/stdc++.h>
using namespace std;

#define x first 
#define y second

int n;
vector<pair<int, int>> p;

const int MAXN = 300;
const int MAX = 10000;

int main(int argc, char** argv) {
    registerValidation(argc, argv);
    
    n = inf.readInt(3, MAXN);
    inf.readEoln();

    p.resize(n);    
    for (int i = 0; i < n; i++) {
        p[i].x = inf.readInt(-MAX, MAX);
        inf.readSpace();
        p[i].y = inf.readInt(-MAX, MAX);
        inf.readEoln();
    }

    inf.readInt(1, 3);
    inf.readEoln();
    inf.readEof();

    int cc = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            long long a = p[i].y - p[j].y;
            long long b = p[j].x - p[i].x;
            long long c = -a * p[i].x - b * p[i].y;

            ensuref(a != 0 || b != 0, "points coincide");

            for (int k = 0; k < n; k++) {
                ensuref(!(k != i && k != j && a * p[k].x + b * p[k].y + c == 0), "three points on a line");
            }
        }
    }    

    return 0;
}
