#include <bits/stdc++.h>
using namespace std;

#define x first 
#define y second

int n;
vector<pair<int, int>> p;

vector<pair<int, int>> segs;

void makeMove(int u, int v, bool myTurn) {
    if (u > v) {
        int t = u; u = v; v = t;
    }
    segs.push_back({u, v});
    if (myTurn) {
        cout << u + 1 << " " << v + 1 << endl;
    }
}

long long vp(long long x1, long long y1, long long x2, long long y2) {
    return x1 * y2 - x2 * y1;
}

int qq = 0;

bool intersect(long long x1, long long y1, long long x2, long long y2, long long x3, long long y3, long long x4, long long y4) {
    qq++;
    long long vp13 = vp(x2 - x1, y2 - y1, x3 - x1, y3 - y1);
    long long vp14 = vp(x2 - x1, y2 - y1, x4 - x1, y4 - y1);
    long long vp31 = vp(x4 - x3, y4 - y3, x1 - x3, y1 - y3);
    long long vp32 = vp(x4 - x3, y4 - y3, x2 - x3, y2 - y3);
    bool g1 = (vp13 < 0 && vp14 > 0) || (vp13 > 0 && vp14 < 0);
    bool g2 = (vp31 < 0 && vp32 > 0) || (vp31 > 0 && vp32 < 0);
    return g1 && g2;
}

bool validMove(int u, int v) {
    if (u > v) {
        int t = u; u = v; v = t;
    }
    for (int i = 0; i < segs.size(); i++) {
        if (u == segs[i].x && v == segs[i].y) {
            return false;
        }
        if (u == segs[i].x || v == segs[i].y) {
            continue;
        }
        if (intersect(p[u].x, p[u].y, p[v].x, p[v].y, p[segs[i].x].x, p[segs[i].x].y, p[segs[i].y].x, p[segs[i].y].y)) {
            return false;
        }
    }
    return true;
}

void minMove() {
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (validMove(i, j)) {
                makeMove(i, j, true);
                return;
            }
        }
    }
}

int main() {
    cin >> n;
    p.resize(n);    
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }

    int cc = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            long long a = p[i].y - p[j].y;
            long long b = p[j].x - p[i].x;
            long long c = -a * p[i].x - b * p[i].y;

            int pos = 0;
            int neg = 0;
            for (int k = 0; k < n; k++) {
                if (a * p[k].x + b * p[k].y + c > 0) pos++;
                if (a * p[k].x + b * p[k].y + c < 0) neg++;
            }

            if (pos == 0 || neg == 0) {
                cc++;
            }
        }
    }    

    /* 
        n + f - e = 2
        3f - 3 + c = 2e

        f = 2 + e - n

        6 + 3e - 3n - 3 + c = 2e
        e = 3n - 3 - c
    */
    int e = 3 * n - 3 - cc;

    int first = 2 - e % 2;
    cout << first << endl;

    bool myturn = first == 1;

    while (e > 0) {
        if (myturn) {
            minMove();
        } else {
            int u, v;
            cin >> u >> v;
            u--, v--;
            makeMove(u, v, false);
        }
        e--;
        myturn = !myturn;
    }

    int u, v;
    // read 0 0
    cin >> u >> v;
    cerr << qq << endl;
    cerr << segs.size() << endl;
}
