#include "testlib.h"
#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    long long n = stoll(argv[1]);
    int m = stoi(argv[2]);
    int mCopy = m;
    int s = stoi(argv[3]);
    int delta1 = stoi(argv[4]);
    int delta2 = stoi(argv[5]);
    cout << n << " " << m << " " << s << endl;
    vector<long long> colors;
    while (m > delta1) {
        long long x = rnd.next(delta1, delta2);
        long long y = rnd.next(1ll, n);
        if (y + x > n) {
            continue;
        }
        for (long long i = y; i < y + x; i++) {
            colors.push_back(i);
        }
        m -= x;
    }
    for (int i = 0; i < m; i++) {
        colors.push_back(rnd.next(1ll, n));
    }
    shuffle(colors.begin(), colors.end());
    for (int i = 0; i < mCopy - 1; i++) {
        cout << colors[i] << " ";
    }
    cout << colors[mCopy - 1] << endl;
    return 0;
}
