#include <bits/stdc++.h>

#include "testlib.h"
 
using namespace std;
 

vector<pair<int, int>> edges;
 
int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

	int n, m, k;
     
    n = inf.readInt();
    m = inf.readInt();
	k = inf.readInt();
	for (int i = 0; i < n; ++i)
		inf.readInt();
	vector<int> col(n);
	for (auto& x : col)
		x = ouf.readInt(1, k);
	for (int i = 0; i < m; ++i)
	{
		 int a = inf.readInt();
		 int b = inf.readInt();
		 --a, --b;
		 if (col[a] == col[b])
			quitf(_wa, "Vertices %d and %d have the same color ", a + 1, b + 1);
		 int ab = abs(col[a] - col[b]);
		 if (ab == 1 || ab == k - 1)
			 edges.push_back({a, b});
	}
	vector<int> p(n);
	iota(p.begin(), p.end(), 0);
	function<int(int)> getp = [&](int x)
	{
		 return x == p[x] ? x : p[x] = getp(p[x]);
	};
	for (auto x : edges)
	{
		x.first = getp(x.first), x.second = getp(x.second);
		if (x.first != x.second)
			p[x.first] = x.second;
	}
	for (int i = 1; i < n; ++i)
		if (getp(i) != getp(0))
			quitf(_wa, "Problem condition is not satisfied");
 
    quitf(_ok, "n=%d, m=%d, k=%d", n, m, k);
}
