#include <vector>
#include <algorithm>
#include <fstream>
#include<string>
#include <iostream>
#include <map>
# include <set>
#include<cmath>
#include <numeric>
#include <iomanip>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
using namespace std;
#include "testlib.h"

vector<int> color(1e6);

set<pair<int, int>> s;
bool flag = true;
vector<vector<int>> g(1e6);
vector<bool> used(1e6);
vector<int> tin(1e6), fup(1e6);
int timer;

/*
void IS_CUTPOINT(int v) {
	int col = color[g[v][0]];
	for (auto u : g[v]) {
		if (color[u] != color[v] )
		{
			g[u].push_back(v);
			g[v].push_back(u);
			s.insert({ u,v });
			flag = true;
		}
	}
 }



void dfs(int v, int p = -1) {
	used[v] = true;
	tin[v] = fup[v] = timer++;
	int children = 0;
	for (size_t i = 0; i<g[v].size(); ++i) {
		int to = g[v][i];
		if (to == p)  continue;
		if (used[to])
			fup[v] = min(fup[v], tin[to]);
		else {
			dfs(to, v);
			fup[v] = min(fup[v], fup[to]);
			if (fup[to] >= tin[v] && p != -1)
				IS_CUTPOINT(v);
			++children;
		}
	}
	if (p == -1 && children > 1)
		IS_CUTPOINT(v);
}



*/

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);
	int n = atoi(argv[1]);
	int m = atoi(argv[2]);
	int k = atoi(argv[3]);
	int c = atoi(argv[4]);
	
	
	color[0] = rnd.next(1, k);
	for (int i = 1; i < n; i++) {
		int l = rnd.next(max(0, i - c), i - 1); 
		int r = rnd.next(0, min(i - 1, c));
		s.insert({ i,l });
		s.insert({ i,r });
		int curcolor = rnd.next(1, k);
		while (curcolor == color[l]  || curcolor==color[r]) curcolor = rnd.next(1, k);
		color[i] = curcolor;
	}

	for (int i = 0; s.size() < m ; i++) {
		int u = 0, v = 0;
		pair<int, int> p1, p2;
		p1 = { u,v };
		p2 = { v,u };
		while (color[u] == color[v] || (s.count(p1) != 0 || s.count(p2) != 0)) {
			u = rnd.next(0, n - 1);
			v = rnd.next(0, n - 1);
			p1 = { u,v };
			p2 = { v,u };
			g[u].push_back(v);
			g[v].push_back(u);
		}
		s.insert({ u,v });
	}

	/*int h = 0;
	while (h<10) {
		h++;
		timer = 0;
		for (int i = 0; i < n; ++i)
			used[i] = false;
		dfs(0);
	}

	*/




	cout << n << ' ' << s.size() << ' ' << k << "\n";
	for (int i = 0; i < n - 1; i++) {
		cout << color[i] << ' ';
	}
	cout << color[n - 1] << "\n";
	for (auto it = s.begin(); it != s.end(); it++) {
		pair<int, int> p = *it;
		cout << p.first + 1 << ' ' << p.second + 1 << "\n";
	}
}