#include <bits/stdc++.h>

#include "testlib.h"
 
using namespace std;

 
int main(int argc, char* argv[])
{
    registerValidation(argc, argv);
 
	int n = inf.readInt(1, 500000, "n");
	inf.readSpace();
	int m = inf.readInt(0LL, min(500000LL, 1LL * n * (n - 1) / 2), "m");
	inf.readSpace();
	int k = inf.readInt(1, 500000, "k");
	inf.readEoln();
	vector<int> col(n);
	for (int i = 0; i < n; ++i)
	{
		col[i] = inf.readInt(1, k, "col");
		if (i + 1 < n)
			inf.readSpace();
	}
	inf.readEoln();

	set<pair<int, int>> edges;
	for (int i = 0; i < m; i++)
	{
		int u = inf.readInt(1, n, "u");
		inf.readSpace();
		int v = inf.readInt(1, n, "v");
		inf.readEoln();
		--u, --v;
		ensuref(u != v, "Loop!");

		ensuref(edges.count({u, v}) == 0, "Duplicated edge! ");
		edges.insert({u, v});
		edges.insert({v, u});
	}

	for (auto& x : edges)
		ensuref(col[x.first] != col[x.second], "Incorrect coloring");
	vector<int> p(n);
	iota(p.begin(), p.end(), 0);
	function<int(int)> getp = [&](int x)
	{
		 return x == p[x] ? x : p[x] = getp(p[x]);
	};
	for (auto x : edges)
	{
		x.first = getp(x.first), x.second = getp(x.second);
		if (x.first != x.second)
			p[x.first] = x.second;
	}
	for (int i = 1; i < n; ++i)
		ensuref(getp(i) == getp(0), "Graph is not connected");
    inf.readEof();
}
