#include <bits/stdc++.h>

using namespace std;
using nagai = long long;
using ll = long long;

const int N = 500000;
int col[N];
vector<int> g[N];

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i < n; ++i)
		cin >> col[i], --col[i];

	for (int i = 0; i < m; ++i)
	{
		int a, b;
		cin >> a >> b;
		--a, --b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	vector<bool> used(n);
	set<pair<nagai, int>> st;
	nagai cur_rot = 0;
	vector<int> rot_added(n);
	st.insert({0LL, 0});
	while (st.size())
	{
		auto p = *st.begin();
		st.erase(st.begin());
		if (used[p.second])
			continue;
		cur_rot = p.first;
		rot_added[p.second] = cur_rot;
		int u = p.second;
		used[u] = true;
		for (int v : g[u])
		{
			if (!used[v])
			{
				if ((col[u] + 1) % k == col[v] || (col[v] + 1) % k == col[u])
					st.insert(make_pair(cur_rot, v));
				else
				{
					nagai new_rot = col[v] - 1 - col[u];
					while (new_rot < 0)
						new_rot += k;
					new_rot += cur_rot;
					st.insert(make_pair(new_rot, v));
				}
			}
		}
	}
	for (int i = 0; i < n; ++i)
		cout << (col[i] + cur_rot - rot_added[i]) % k + 1 << ' ';
	cout << '\n';
	return 0;
}

