/**
 * Sergey Kopeliovich (burunduk30@gmail.com)
 */

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) a.begin(), a.end()

void solve() {
	int n;
	int64_t W;
	cin >> n >> W;
	struct Item {
		int w, cost, id;
	};
	vector<Item> a(n);
	forn(i, n)
		cin >> a[i].w >> a[i].cost;

	vector<int> ids, ans;
	int64_t best = 0;
	function<void(int, int64_t, int64_t)> go = [&](int i, int64_t sum_w, int64_t sum_cost) {
		if (sum_w > W)
			return;
		// printf("i=%d : %ld %ld\n", i, sum_w, sum_cost);
		if (i == n) {
			if (best < sum_cost)
				best = sum_cost, ans = ids;
			return;
		}
		go(i + 1, sum_w, sum_cost);
		ids.push_back(i);
		go(i + 1, sum_w + a[i].w, sum_cost + a[i].cost);
		ids.pop_back();
	};
	go(0, 0, 0);

	cout << ans.size() << "\n";
	for (int i : ans)
		cout << i + 1 << " ";
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);

	int tn;
	cin >> tn;
	while (tn--)
		solve();
}
