#include <bits/stdc++.h>
using namespace std;

typedef long long int64;

    
int main() {
    int n, k;
    cin >> n >> k;
    int N = max(n, k);

    vector<vector<int64>> ch(N + 1, vector<int64>(N + 1));
    ch[0][0] = 1;
    for (int i = 1; i <= N; i++) {
        ch[i][0] = 1;
        for (int j = 1; j <= N; j++) {
            ch[i][j] = ch[i - 1][j - 1] + ch[i - 1][j];
        }
    }

    vector<vector<int64>> s(N + 1, vector<int64>(N + 1));
    vector<vector<int64>> sx(N + 1, vector<int64>(N + 1));
    vector<vector<int64>> sps(N + 1, vector<int64>(N + 1));

    vector<int64> fac(N + 1);
    fac[0] = 1;
    for (int i = 1; i <= k; i++) {
        fac[i] = fac[i - 1] * i;
    }

    fill(s[0].begin(), s[0].end(), 1);
    sx[0][0] = 1;
    sps[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            s[i][j] = s[i][j - 1] + (i >= j ? s[i - j][j] : 0);
            sx[i][j] = s[i][j] - s[i][j - 1];
            sps[i][j] = sps[i][j - 1] + sx[i][j] * ch[k][j] * fac[j];
//            cout << i << " " << j << " " << sx[i][j] << " " << sx[i][j] * ch[k][j] * fac[j] << endl;
        }
//        cout << endl;
    }



    vector<vector<int64>> a(n + 1, vector<int64>(n + 1));
    fill(a[0].begin(), a[0].end(), 1);
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= i; j++) {
            for (int t = 0; t * j <= i; t++) {
                a[i][j] += a[i - t * j][j - 1] * sps[t][t];
//                cout << "a" << " " << i << " " << j << " " << a[i][j] << endl;
            }
        }
    }

    cout << a[n][n] << endl;

    return 0;
}
