// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;


int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int rot = opt<int>(1);
	int flip = opt<int>(2);

	int n, m;
	cin >> n >> m;
	vector<vector<int>> field(m, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			field[i][j] = s[j] == '.' ? -1 : s[j] - '0';
		}
	}

	for (int qwe = 0; qwe < rot; ++qwe) {
		vector<vector<int>> next_field(m, vector<int>(n));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				int val = field[i][j];
				if (val != -1) {
					val = (val + 3) % 4;
				}
				next_field[m - 1 - j][i] = val;
			}
		}
		swap(field, next_field);
	}

	if (flip) {
		vector<vector<int>> next_field(n, vector<int>(m));
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				int val = field[i][j];
				if (val == 2 || val == 0) {
					val ^= 2;
				}
				next_field[i][m - 1 - j] = val;
			}
		}
		swap(field, next_field);
	}

	cout << n << " " << n << "\n";
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (field[i][j] == -1) {
				cout << '.';
			} else {
				cout << field[i][j];
			}
		}
		cout << "\n";
	}

	return 0;
}