#include <bits/stdc++.h>
using namespace std;
 
const int INF = 1e9 + 10;

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0); 
  int n;
  cin >> n;
  vector<int> a(n);
  int sum = 0;
  for (int i = 0; i < n; i++) {
  	cin >> a[i];
    sum += a[i];
  }
  vector<vector<int>> cost(n, vector<int>(n));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      cin >> cost[i][j];
  	}
  }
  if (sum & 1) {
    cout << -1 << '\n';
    return 0;
  }
  int answer = 0;
  while (sum > 0) {
    int bestCost = INF;
    pair<int, int> take = {-1, -1};
    for (int i = 0; i < n; i++) {
      if (a[i] >= 2) {
        if (cost[i][i] < bestCost) {
          bestCost = cost[i][i];
          take = {i, i};
        }
      }
      for (int j = i + 1; j < n; j++) {
        if (a[i] > 0 && a[j] > 0 && cost[i][j] < bestCost) {
          bestCost = cost[i][j];
          take = {i, j};
        }
      }
    }
    answer += bestCost;
    a[take.first]--;
    a[take.second]--;
    sum -= 2;
  }
  cout << answer << '\n';
  return 0;
}     