#include "testlib.h"
#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    long long n = stoll(argv[1]);
    int m = stoi(argv[2]);
    int s = stoi(argv[3]);
    int delta1 = stoi(argv[4]);
    int delta2 = stoi(argv[5]);
    cout << n << " " << m << " " << s << endl;
    long long last = 1;
    vector<long long> colors;
    for (int i = 0; i < m; i++) {
        long long x;
        if (last == n) {
            x = n;
        } else {
            x = rnd.next(last + delta1, min(n, last + delta2));
        }
        colors.push_back(x);
        last = x;
    }
    shuffle(colors.begin(), colors.end());
    for (int i = 0; i < m - 1; i++) {
        cout << colors[i] << " ";
    }
    cout << colors[m - 1] << endl;
    return 0;
}
