/**
 * Sergey Kopeliovich (burunduk30@gmail.com)
 */

#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)(n); i++)
#define all(a) a.begin(), a.end()

void solve() {
	int n = 0, n0;
	int64_t W;
	cin >> n0 >> W;
	struct Item {
		int w, cost, id;
	};
	vector<Item> a(n0);
	forn(i, n0) {
		cin >> a[n].w >> a[n].cost, a[n].id = i;
		if (a[n].w <= W)
			n++;
	}
	a.resize(n);

	sort(all(a), [](auto a, auto b) {
		return (int64_t)a.cost * b.w > (int64_t)b.cost * a.w;
	});

	int64_t best = 0;
	W = 3 * W / 2;
	vector<int> ans, ids;

	auto test = [&](int i) {
		int64_t sum_w = 0, sum_cost = 0;
		ids.clear();
		auto add = [&](int j) {
			ids.push_back(a[j].id);
			sum_w += a[j].w, sum_cost += a[j].cost;
		};
		if (i != -1)
			add(i);
		for (int j = 0; j < n; j++) 
			if (j != i && sum_w + a[j].w <= W)
				add(j);
		if (best < sum_cost)
			best = sum_cost, ans = ids;
	};

	test(-1);
	forn(i, n)
		test(i);

	cout << ans.size() << "\n";
	for (int i : ans)
		cout << i + 1 << " ";
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(0), cin.tie(0);

	int tn;
	cin >> tn;
	while (tn--)
		solve();
}
